import 'reflect-metadata';
export declare class ClassMetaNode {
    private readonly stacks;
    set<T = any>(key: string | symbol, value: T): this;
    get<T = any>(key: string | symbol): T;
    get size(): number;
    has(key: string | symbol): boolean;
    get isEmpty(): boolean;
    got<R = any>(name: string | symbol, defaultValue?: R): R;
}
export declare class ClassMetaCreator {
    static namespace: symbol;
    readonly stacks: Map<Object, ClassMetaNode>;
    static instance(obj: Object): ClassMetaNode;
    static define<T = any>(key: string | symbol, value: T): ClassDecorator;
    static push(key: string | symbol, ...args: any[]): ClassDecorator;
    static unshift(key: string | symbol, ...args: any[]): ClassDecorator;
    static join(...args: ClassDecorator[]): ClassDecorator;
}
