import 'reflect-metadata';
import { MethodMetaCreator } from './methodMetaCreator';
declare type ParameterHandler<TContext = any, TResult = any> = (ctx: TContext, ...args: any[]) => TResult | Promise<TResult>;
export declare class ParameterMetaCreator {
    static namespace: symbol;
    private readonly stacks;
    parent: MethodMetaCreator;
    setParent(value: MethodMetaCreator): void;
    get size(): number;
    set<T = any, R = any>(index: number, callback: ParameterHandler<T, R>): this;
    get<T = any, R = any>(index: number, ctx?: T, ...args: any[]): R | Promise<R>;
    exec<T = any, R = any>(ctx: T): Promise<R[]>;
    static instance(obj: Object): ParameterMetaCreator;
    static define<T = any, R = any>(callback: ParameterHandler<T, R>): ParameterDecorator;
    static pushToParent(key: string, ...args: any): ParameterDecorator;
    static unshiftToParent(key: string, ...args: any): ParameterDecorator;
    static joinToParent(...args: ParameterDecorator[]): ParameterDecorator;
}
export {};
