import { Router } from './router';
import { FunctionComponent } from 'react';
import { TMiddlewareState } from './interface';
export interface THistory {
    mode: 'hashchange' | 'popstate';
    listener: () => void;
    notFoundComponent: FunctionComponent;
}
export declare const History: THistory;
export declare function createHistory(router: Router, mode: 'hashchange' | 'popstate', set: React.Dispatch<React.SetStateAction<TMiddlewareState<any, any>[]>>): () => () => void;
