import React from 'react';
import { Container } from 'inversify';
import { createHistory, THistory } from './history';
import { redirect, replace, useLocation, useQuery, useParam } from './request';
import { TSloxComponent, GetSloxProps, TClassComponent } from './interface';
export * from 'inversify';
export * from '@vue/reactivity';
export * from './interface';
export * from './annotates';
export * from './decorators';
export * from './state';
export * from './promise';
export * from './imports';
export { redirect, replace, useLocation, useQuery, useParam, };
export declare const container: Container;
export declare function createServer(): {
    bootstrap: <E extends HTMLElement = HTMLElement>(mode: Parameters<typeof createHistory>[1], el: E) => void;
    createNotFoundComponent: (component: THistory['notFoundComponent']) => React.FunctionComponent<{}>;
    useGlobalMiddlewares: <T, O>(m: TSloxComponent<T, O>, p?: T) => void;
    defineController: (...controls: TClassComponent<any, any>[]) => void;
};
