import 'reflect-metadata';
import { ClassMetaNode } from './classMetaCreator';
export declare class MethodMetaCreator {
    static namespace: symbol;
    private readonly stacks;
    parent: ClassMetaNode;
    setParent(value: ClassMetaNode): void;
    set<T = any>(key: string | symbol, value: T): this;
    get<T = any>(key: string | symbol): T;
    get size(): number;
    has(key: string | symbol): boolean;
    get isEmpty(): boolean;
    got<R = any>(name: string | symbol, defaultValue?: R): R;
    static instance<T = any>(obj: TypedPropertyDescriptor<T>): MethodMetaCreator;
    static define<T = any>(key: string | symbol, value: T): MethodDecorator;
    static push(key: string | symbol, ...args: any[]): MethodDecorator;
    static unshift(key: string | symbol, ...args: any[]): MethodDecorator;
    static join(...args: MethodDecorator[]): MethodDecorator;
}
