import React from 'react';
import { TClassComponent } from '..';
import { TComponent } from '../interface';
export declare function Component(): ClassDecorator;
export declare namespace Component {
    var namespace: symbol;
}
export declare function Service(): ClassDecorator;
export declare namespace Service {
    var namespace: symbol;
}
export declare const WrapNamespace: unique symbol;
export declare function useComponentWithClass<T, O>(component: TClassComponent<T, O>): O extends HTMLElement ? React.ForwardRefExoticComponent<T & React.RefAttributes<O>> : React.FunctionComponent<T>;
export declare function useComponentWithMethod<T, C, O>(component: TComponent<T, O>, context: C): O extends HTMLElement ? React.ForwardRefExoticComponent<T & React.RefAttributes<O>> : React.FunctionComponent<T>;
export declare function useComponent<T, O>(component: {
    render: TComponent<T, O>;
}): O extends HTMLElement ? React.ForwardRefExoticComponent<T & React.RefAttributes<O>> : React.FunctionComponent<T>;
export declare function isIocComponent<T, O>(component: TClassComponent<T, O>): boolean;
